<!-- eslint-disable max-len -->
<template>
  <b-container>
    <h1>New Announcement</h1>
    <hr>
    <b-alert
      v-model="showErrorMessage"
      class="mb-2"
      dismissible
      variant="danger"
    >
      {{ errorMessage }}
    </b-alert>
    <b-form @submit.prevent="submit">
      <b-form-group label="Message">
        <b-form-textarea
          v-model="announcement.message"
          :disabled="submitting"
          :state="$v.announcement.message.$dirty ? ($v.announcement.message.$invalid ? false : true) : null"
          rows="3"
          @input="$v.announcement.message.$touch"
        />
        <b-form-invalid-feedback v-if="$v.announcement.message.$dirty && !$v.announcement.message.required">
          Field is required.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Display Type">
        <b-form-select
          v-model="announcement.variant"
          :disabled="submitting"
          :state="$v.announcement.variant.$dirty ? ($v.announcement.variant.$invalid ? false : true) : null"
          :options="variants"
          @input="$v.announcement.variant.$touch"
        />
        <b-form-invalid-feedback v-if="$v.announcement.variant.$dirty && !$v.announcement.variant.required">
          Field is required.
        </b-form-invalid-feedback>
      </b-form-group>
      <b-form-group label="Make Active Immediately">
        <b-form-checkbox
          v-model="announcement.active"
          :disabled="submitting"
          :state="$v.announcement.active.$dirty ? ($v.announcement.active.$invalid ? false : true) : null"
          switch
          @input="$v.announcement.active.$touch"
        />
      </b-form-group>
      <hr>
      <div style="overflow: hidden;">
        <div class="float-right">
          <b-button
            :disabled="submitting"
            :to="{ name: 'announcementList' }"
            class="mr-1"
            variant="danger"
          >
            <font-awesome-icon icon="times" />
            Cancel
          </b-button>
          <b-button
            :disabled="$v.$invalid || submitting"
            type="submit"
            variant="success"
          >
            <font-awesome-icon
              v-if="submitting"
              icon="spinner"
              pulse
            />
            <font-awesome-icon
              v-else
              icon="check"
            />
            Submit
          </b-button>
        </div>
      </div>
    </b-form>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import { maxLength, required } from 'vuelidate/lib/validators';

import { AnnouncementService } from '@/api';

export default Vue.extend({
  data() {
    return {
      errorMessage: '',
      showErrorMessage: false,
      submitting: false,
      announcement: {
        message: '',
        variant: 'info',
        active: false,
      },
      variants: ['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark'],
    };
  },

  validations: {
    announcement: {
      message: {
        required,
        maxLength: maxLength(2048),
      },
      variant: {
        required,
      },
      active: {
        required,
      },
    },
  },

  methods: {
    async submit(): Promise<void> {
      this.submitting = true;
      try {
        await AnnouncementService.create({
          ...this.announcement,
        });
      } catch (errors) {
        this.errorMessage = `
          There was an error creating your announcement: ${errors[0].detail}.
        `;
        this.showErrorMessage = true;
        return;
      } finally {
        this.submitting = false;
      }
      this.$router.push({
        name: 'announcementList',
      });
    },
  },
});
</script>
